#ifndef __CONFIG_H__
#define __CONFIG_H__

#include "pindef.h"

// Device Address
#define DEVICE_ADDRESS				1

// Firmware
#define FW_VERSION_MAJ				1
#define FW_VERSION_MIN				0
#define FW_VERSION_PATCH			0
#define FW_VERSION_SUFFIX

// Communication
#define SERVER_ADDR					0xFFF0

// RTC
#define RTC_TICK_FREQ				1000	// [ms]

// BMP280	(Temperature-pressure sensor)
#define BMP280_I2C					0

// SPI config
#define SPI_INDEX					0
#define NRF_SPI						0
#define SPI_0_FREQ					1000000

// LCD e-ink
#define EINK_SPI					0
#define EINK_HEIGHT					296
#define EINK_WIDTH					128

// User Interface
#define BUTTON_TIME					50		// [ms]		Disable button scanning time
#define BUTTON_ONSCREEN_TIME		10		// [s]
#define UI_RETURN_TIME				60		// [s]		Return to main page

// EEPROM
#define EEPROM_SIZE					512
#define EEPROM_PAGE_SIZE			16

// Ext Flash
#define EXTFLASH_SIZE		    	2097152
#define EXTFLASH_SELECT(addr)		FLASH_CS_Clear()//, delayus_fcn(10)
#define EXTFLASH_UNSELECT()			FLASH_CS_Set()//, delayus_fcn(10)

// ADC
#define ADC_RESOLUTION				kAdc16ResolutionBitOfSingleEndAs16

// Battery
#define BATT_MIN_VOLTAGE			2500	// [mV]
#define BATT_MAX_VOLTAGE			3000	// [mV]

// Others
#define DefaultISR					HardFault
#define WAKE_UP_TIME				10000000	// [us]
#define MEASURE_INTERVAL			300		// [s]		Each 5 minutes
#define MEASURE_HIST_DEPTH			96		// samples
#define MEASURE_HIST_AVG_SAMP		3		// samples (1 sample in history table is result of averaging this numbers of samples)

#endif
