#include <pinmux.h>
#include <fsl_port_hal.h>

const pin_struct_t pin_definitions_run[] =
{
    /* PIN NAME		   | port | pin |  irq     | mux | pe | ds |  mode | value */

	/* FLASH_CS		*/ {  IO_D,	   6,  DISABLED, ALT1,	 0,   0, OUTPUT,  1 },
	/* EEPROM_CS	*/ {  IO_D,	   7,  DISABLED, ALT1,	 0,   0, OUTPUT,  1 },

	/* LEDB		  	*/ {  IO_C,    2,  DISABLED, ALT1,   0,   0, OUTPUT,  0 },
	/* LEDR		  	*/ {  IO_C,    0,  DISABLED, ALT1,   0,   0, OUTPUT,  0 },

	/* RX_S         */ {  IO_E,   21,  DISABLED, ALT1,   1,   0,  INPUT,  0 },
	/* TX_S         */ {  IO_E,   20,  DISABLED, ALT1,   1,   0,  INPUT,  0 },

	/* SCK0			*/ {  IO_C,    5,  DISABLED, ALT2,   0,   0, OUTPUT,  1 },
	/* MISO0		*/ {  IO_C,    6,  DISABLED, ALT5,   1,   0,  INPUT,  0 },
	/* MOSI0		*/ {  IO_C,    7,  DISABLED, ALT5,   0,   0, OUTPUT,  1 },

	/* NRF_IRQ		*/ {  IO_B,    0,   INT_RIS, ALT1,   1,   0,  INPUT,  0 },
	/* NRF_CS		*/ {  IO_B,    1,  DISABLED, ALT1,   0,   0, OUTPUT,  1 },
	/* NRF_CE		*/ {  IO_B,    2,  DISABLED, ALT1,   0,   0, OUTPUT,  0 },

	/* SW_DOWN		*/ {  IO_C,    1,  DISABLED, ALT1,   1,   0,  INPUT,  0 },
	/* SW_UP		*/ {  IO_C,    4,  DISABLED, ALT1,   1,   0,  INPUT,  0 },
	/* SW_OK		*/ {  IO_C,    3,  DISABLED, ALT1,   1,   0,  INPUT,  0 },

	/* DISP_RST		*/ {  IO_D,    2,  DISABLED, ALT1,   0,   0, OUTPUT,  1 },
	/* DISP_DC		*/ {  IO_D,    3,  DISABLED, ALT1,   0,   0, OUTPUT,  1 },
	/* DISP_BUSY	*/ {  IO_D,    4,  DISABLED, ALT1,   1,   0,  INPUT,  0 },
	/* DISP_CS		*/ {  IO_D,    5,  DISABLED, ALT1,   0,   0, OUTPUT,  1 },

	/* SDA			*/ {  IO_E,   18,  DISABLED, ALT4,   0,   0,  INPUT,  0 },
	/* SCL			*/ {  IO_E,   19,  DISABLED, ALT4,   0,   0, OUTPUT,  1 },

	/* HARD_RESET	*/ {  IO_A,    4,  DISABLED, ALT1,   1,   0,  INPUT,  0 },
};

const pin_struct_t pin_definitions_stop[] =
{
	/* PIN NAME		   | port | pin |  irq     | mux | pe | ds |  mode | value */

	/* FLASH_CS		*/ {  IO_D,	   6,  DISABLED, ALT1,	 0,   0, OUTPUT,  1 },
	/* EEPROM_CS	*/ {  IO_D,	   7,  DISABLED, ALT1,	 0,   0, OUTPUT,  1 },

	/* LEDB		  	*/ {  IO_C,    2,  DISABLED, ALT1,   0,   0, OUTPUT,  0 },
	/* LEDR		  	*/ {  IO_C,    0,  DISABLED, ALT1,   0,   0, OUTPUT,  0 },

	/* RX_S         */ {  IO_E,   21,  DISABLED, ALT1,   1,   0,  INPUT,  0 },
	/* TX_S         */ {  IO_E,   20,  DISABLED, ALT1,   1,   0,  INPUT,  0 },

	/* SCK0			*/ {  IO_C,    5,  DISABLED, ALT2,   0,   0, OUTPUT,  1 },
	/* MISO0		*/ {  IO_C,    6,  DISABLED, ALT5,   1,   0,  INPUT,  0 },
	/* MOSI0		*/ {  IO_C,    7,  DISABLED, ALT1,   0,   0, OUTPUT,  0 },

	/* NRF_IRQ		*/ {  IO_B,    0,   INT_RIS, ALT1,   1,   0,  INPUT,  0 },
	/* NRF_CS		*/ {  IO_B,    1,  DISABLED, ALT1,   0,   0, OUTPUT,  1 },
	/* NRF_CE		*/ {  IO_B,    2,  DISABLED, ALT1,   0,   0, OUTPUT,  0 },

	/* SW_DOWN		*/ {  IO_C,    1,  INT_FALL, ALT1,   1,   0,  INPUT,  0 },
	/* SW_UP		*/ {  IO_C,    4,  INT_FALL, ALT1,   1,   0,  INPUT,  0 },
	/* SW_OK		*/ {  IO_C,    3,  INT_FALL, ALT1,   1,   0,  INPUT,  0 },

	/* DISP_RST		*/ {  IO_D,    2,  DISABLED, ALT1,   0,   0, OUTPUT,  1 },
	/* DISP_DC		*/ {  IO_D,    3,  DISABLED, ALT1,   0,   0, OUTPUT,  1 },
	/* DISP_BUSY	*/ {  IO_D,    4,  INT_FALL, ALT1,   1,   0,  INPUT,  0 },
	/* DISP_CS		*/ {  IO_D,    5,  DISABLED, ALT1,   0,   0, OUTPUT,  1 },

	/* SDA			*/ {  IO_E,   18,  DISABLED, ALT4,   0,   0,  INPUT,  0 },
	/* SCL			*/ {  IO_E,   19,  DISABLED, ALT4,   0,   0, OUTPUT,  1 },

	/* HARD_RESET	*/ {  IO_A,    4,  DISABLED, ALT1,   1,   0,  INPUT,  0 },
};

void Pindef_Init()
{
	pinmux_init(pin_definitions_run, sizeof(pin_definitions_run) / sizeof(pin_struct_t));
}

void Pindef_DeInit()
{
	pinmux_init(pin_definitions_stop, sizeof(pin_definitions_stop) / sizeof(pin_struct_t));
}
