#ifndef __PINDEF_H__
#define __PINDEF_H__

#include <gpio.h>

// --------------------------------------------------------------------------
MAKE_GPIO(LedB,          PT_C,  2);
MAKE_GPIO(LedR,          PT_C,  0);

MAKE_GPIO(EEPROM_CS,     PT_D,  7);
MAKE_GPIO(FLASH_CS,      PT_D,  6);

MAKE_GPIO(DISP_RST,      PT_D,  2);
MAKE_GPIO(DISP_DC,       PT_D,  3);
MAKE_GPIO(DISP_BUSY,     PT_D,  4);
MAKE_GPIO(DISP_CS,       PT_D,  5);

MAKE_GPIO(SW_DOWN,       PT_C,  1);
MAKE_GPIO(SW_UP,         PT_C,  4);
MAKE_GPIO(SW_OK,         PT_C,  3);

MAKE_GPIO(NRF_IRQ,       PT_B,  0);
MAKE_GPIO(NRF_CS,        PT_B,  1);
MAKE_GPIO(NRF_CE,        PT_B,  2);


// --------------------------------------------------------------------------
#define LED_PIN(name, val)	((val == true) ? name##_Set() : name##_Clear())

// --------------------------------------------------------------------------
#define spi_eeprom_select() 	EEPROM_CS_Clear()
#define spi_eeprom_unselect()	EEPROM_CS_Set()

#define EXTFLASH_SELECT(addr)	FLASH_CS_Clear()
#define EXTFLASH_UNSELECT()		FLASH_CS_Set()
#define EXTFLASH_CS(val)		((val == true) ? FLASH_CS_Set() : FLASH_CS_Clear())

// E-Ink display
#define EINK_RST(val)			DISP_RST_Write(val)
#define EINK_DATA()				DISP_DC_Set()
#define EINK_CMD()				DISP_DC_Clear()
#define EINK_BUSY				DISP_BUSY_Read()
#define EINK_CS(val)			DISP_CS_Write(val)
#define EINK_SELECT()			EINK_CS(0)
#define EINK_UNSELECT()			EINK_CS(1)


// NRF24L01
#define NRF_IRQ					NRF_IRQ_Read()
#define NRF_CE(val)				NRF_CE_Write(val)
#define NRF_ENABLED()			NRF_CE(1)
#define NRF_DISABLED();			NRF_CE(0)
#define NRF_CS(val)				NRF_CS_Write(val)
#define NRF_SELECT()			NRF_CS(0)
#define NRF_UNSELECT()			NRF_CS(1)


extern void Pindef_Init();
extern void Pindef_DeInit();

#endif
