#include "powermodes.h"
#include <fsl_pmc_hal.h>

// --------------------------------------------------------------------------
power_manager_error_code_t power_state_callback(power_manager_notify_struct_t * notify, power_manager_callback_data_t * dataPtr)
{
	return kPowerManagerSuccess;
}

// --------------------------------------------------------------------------
const power_manager_user_config_t runConfig = {
		kPowerManagerRun,
		false,
		kSmcPorEnabled,
		kSmcPstopStop
};
const power_manager_user_config_t vlpsConfig = {
		kPowerManagerVlps,			// Very low power stop mode
		false,						// Stay wake up after ISR completed
		kSmcPorEnabled,				// Power on reset detection circuit enabled
		kSmcPstopStop
};
pmc_bandgap_buffer_config_t bandgapConfig = {
		true,						// Bandgap buffer enabled
		false						// Disabled in low power mode
};
power_manager_callback_user_config_t pwrCallback = {
		power_state_callback,
		kPowerManagerCallbackBeforeAfter,
		NULL
};
power_manager_callback_user_config_t * callbacks[] = { &pwrCallback };
power_manager_user_config_t const * configs[] = { &runConfig, &vlpsConfig };

// --------------------------------------------------------------------------
void pwr_init(void)
{
	SMC_HAL_SetProtection(SMC, kAllowPowerModeVlp);
	PMC_HAL_BandgapBufferConfig(PMC, &bandgapConfig);
	PMC_HAL_ClearAckIsolation(PMC);

	POWER_SYS_Init(configs, 2U, callbacks, 1U);
	POWER_SYS_SetWakeupModule(kPowerManagerWakeupModule7, true); // Wakeup on RTC second
	//POWER_SYS_SetWakeupModule(kPowerManagerWakeupModule5, true); // Wakeup on RTC alarm
	POWER_SYS_SetMode(0U, kPowerManagerPolicyAgreement);
}
