#include "delay.h"
#include <stdint.h>

extern uint32_t SystemCoreClock;

// --------------------------------------------------------------------------
void delay(volatile unsigned int dly) // [ms]
{
	delayus(1000 * dly);
}

// --------------------------------------------------------------------------
void delay_us(volatile unsigned int dly)
{
  // cycles
  dly *= SystemCoreClock / 1000000;  // delay clocks/cycles

  // overhead correction
  if(dly > OVERHEAD_CLOCKS)
    dly -= OVERHEAD_CLOCKS;
  else
    dly = 0;

  dly = ((dly / 10) + 1) * 10; // Next 10 divisible value
  while(dly > 0)  // 10 clocks overhead
    dly -= 10;
}  // delay_us()

